;=======
;TOOLBAR
;=======

on *:START:{ 
  tbar 
  laglogo.start 
  lag.test
}

alias tbar {

  toolbar -r
  var %i = 1
  while (%i <= 22) {
    toolbar -d 13
    inc %i
  }

  toolbar -az1 profils "Connexion" $fichier(system\images\icones\serv.ico) /profils
  toolbar -az1 config "Configuration" $fichier(system\images\config\options.ico) /config
  toolbar -az1 themes "Thmes" $fichier(system\images\themes\couleurs.ico) /themes

  toolbar -as s1

  if $hget(Sys-Options,sons.isactive) { toolbar -az1 son "Dsactiver les sons" $fichier(system\images\icones\sonon.ico) /tbar_sonoff }
  else toolbar -az1 son "Activer les sons" $fichier(system\images\icones\sonoff.ico) /tbar_sonon

  toolbar -as s2

  toolbar -az1 scan "Scanner" $fichier(system\images\icones\_scan.ico) /scan
  toolbar -az1 notify "Liste des notifis" $fichier(system\images\icones\_scan2.ico) /notify

  toolbar -as s3

  toolbar -az1 maint "Maintenance du script" $fichier(system\images\icones\file.ico) /maint

  toolbar -as s4

  if ($script(logviewer.mrc)) toolbar -az1 lv "Logviewer" $fichier(system\images\icones\_logs.ico) /lv
  if ($script(away.mrc)) toolbar -az1 aw "Rpondeur/Anti-Pv/Away" $fichier(system\images\icones\aw.ico) /aw
  if ($script(quote.mrc)) toolbar -az1 quoteur "Quoteur" $fichier(system\images\icones\quoteur.ico) /quoteur
  if ($script(radio.mrc)) toolbar -az1 sradio "Lecteur Radio" $fichier(system\images\icones\sound.ico) /sradio

  if $script(logviewer.mrc) || $script(away.mrc) || $script(quote.mrc) { toolbar -as s5 }

  toolbar -az1 tsmax "Rejoindre #TSMax sur Euro-Tchat" $fichier(TS4.ico) /tsmax
  toolbar -az1 help "Aide" $fichier(system\images\icones\help.ico) /help

}

alias tbar_sonon {
  hadd -m Sys-Options sons.isactive 1
  toolbar -pz1 Son $fichier(system\images\icones\sonon.ico)
  toolbar -t Son "Dsactiver les sons"
  toolbar -l Son /tbar_sonoff
}
alias tbar_sonoff {
  hadd -m Sys-Options sons.isactive 0
  toolbar -pz1 Son $fichier(system\images\icones\sonoff.ico)
  toolbar -t Son "Activer les sons"
  toolbar -l Son /tbar_sonon
}

;-LAGBAR/LOGO------------------------------------------------------------------------------------------------------------

Alias clearall clearall | laglogo.start
Alias laglogo.start {
  laglogo.end
  window -Bph +d @_tool 0 0 150 24 | window -Bph +d @_tool2 0 0 88 31
  tbwin Attach @_tool | tbwin Attach @_tool2
  ; Place it in the right spot.
  var %z = $dll($_tbwin, GetTBInfo, NOT_USED)
  var %w = $gettok(%z, 1, 32)
  var %h = $gettok(%z, 2, 32)
  laglogo.size %w %h
  tbwin OnSize /laglogo.size
  laglogo.update
  window -a @_tool
  window -a @_tool2
}
Alias laglogo.end { 
  dll -u $_tbwin | close -@ @_tool | .timerlag.* off
  dll -u $_tbwin | close -@ @_tool2
}
Alias laglogo.size {
  window @_tool $calc($1 - 120) $int($calc(($2 - 27) / 2)) 120 27
  window @_tool2 $calc($1 - 201) $int($calc(($2 - 27) / 2)) 79 27
}
alias laglogo.update {
  ;lag
  if $window(@_tool) {
    drawfill -r @_tool 0 0 0 0
    if ($status != connected) { lag.na }
    else { lag.chk }
  }
  ;logo
  if $window(@_tool2) {
    if ($status != connected) { logo.na }
    else { logo.chk }
  }
}
alias -l lag.color return $rgb(255,255,255)
alias lag.color2 {
  if ($1 < 1) {
    var %a = $floor($calc(255 * $1)) , %b = $floor($calc(192 + %a / 4))
    return $rgb(%a,%b,0)
  }
  if ($1 < 2) {
    var %c = $floor($calc(255 * (2 - $1)))
    return $rgb(255,%c,0)
  }
  if ($1 < 10) {
    var %d = $floor($calc(128 * ($1 - 2) / 8)) , %e = $floor($calc(255 - %d / 5))
    return $rgb(%e,0,%d)
  }
  return $rgb(229,0,128)
}
alias -l lag.na { 
  clear -@ @_tool 
  drawfill -r @_tool 0 0 0 0 
  drawrect -r @_tool $lag.color 1 1 1 116 12 
  drawtext -rb @_tool $lag.color 0 Verdana 9 1 14 Dconnect 
}
alias -l lag.chk { if ($server) && ($istok(disconnected;closing;loggingon,$status,59) == $false) { scid $cid raw -q ping lag $+ $ticks } | else { lag.na } | .timerlag.chk -o 1 20 lag.chk }
alias -l logo.na { drawpic @_tool2 0 0 $fichier(System\images\connexion\mirc.png) }
alias -l logo.chk { if ($server) && ($istok($status,disconnected;closing;loggingon,59) == $false) && $findfile($fichier(System\images\connexion\),$+($_network,.png),1) { drawpic @_tool2 0 0 $findfile($fichier(System\images\connexion\),$+($_network,.png),1) } | else { logo.na } }
alias -l lag.fresh {
  ;$1 = nb secondes lag, $2 = server
  var %x = 122 , %x2 = $calc(%x - 8), %lag = $int($calc($1 * %x2 / 2)) , %x3 = $calc(%x2 - 2)
  var %y = $iif($1 < 60,$iif($1 < 10,$1,$round($1,1)) $+ s,$dure($1))
  if (!$3) {
    var %msg1 = $iif($_network,$v1,$2-) , %lmsg1 = $len(%msg1)
    var %msg = $iif(%lmsg1 <= 16,%msg1,$left(%msg1,15) $+ ?) : %y
    clear -@ @_tool
    drawfill -nr @_tool 0 0 0 0
    drawrect -nr @_tool $lag.color 1 1 1 %x2 12
    drawtext -nrb @_tool $lag.color 0 Tahoma 9 1 14 %msg
  }
  drawrect -nrf @_tool 0 1 2 2 $calc(%x2 - 2) 10
  drawrect -nrf @_tool $lag.color2($1) 1 2 2 $iif(%lag <= %x3,%lag,%x3) 10
  drawdot @_tool
}
alias lag.test {
  var %x 0,%i 0
  while (%x <= 2) {
    .timer -h 1 %i lag.fresh %x 1 1
    inc %x 0.05
    inc %i 15
  }
  while %x {
    .timer -h 1 %i lag.fresh %x 1 1
    dec %x 0.05
    inc %i 15
  }
  .timer -h 1 %i lag.chk
}
on ^*:PONG:{ if (lag* iswm $2) { lag.fresh $round($calc(($ticks - $right($2,-3)) / 1000),2) $2 } | halt }
raw 004:*:laglogo.update
on *:DISCONNECT:laglogo.update
on *:EXIT:laglogo.update
on *:ACTIVE:*:if ($lactivecid != $activecid) { laglogo.update }
on *:LOAD:laglogo.start | lag.test
on *:UNLOAD:laglogo.end
Menu @_tool {
  .Tester la lagbar:/lag.test
}
