;===============
;GESTION NICKSERV
;===============

Menu menubar {
  Gestion NickServ $chr(9) /nsconf:/nsconf
}

on *:start:ns.conv

;dchargement de l'ancien module et conversion du fichier nickserv
alias ns.conv {
  var %f = $fichier(System\modules\ns.txt) , %g = $nsf
  if !$isfile(%g) && $isfile(%f) {
    var %i = 1 , %l = $lines(%f) | while (%i <= %l) {
      var %a = $read(%f,%i)
      write %g $remove(%a,(\|.+)?)
      inc %i
    }
    .remove %f
    if $fichier($script(nickserv.mrc)) && (\system\modules\nickserv.mrc isin $v1) { .unload -rs $v2 }
  }
}

alias nsf var %f = $fichier(System\data\ns.txt) | if $isid { return %f } | run %f

alias nsconf _d nsconf
dialog nsconf {
  title Gestion NickServ - /nsconf - $tsmax
  size -1 -1 256 121
  option dbu
  list 1, 5 5 246 90
  button "Ajouter", 2, 5 93 80 10
  button "Supprimer", 3, 88 93 80 10
  button "Modifier", 4, 171 93 80 10
  button "Valider", 5, 203 106 50 12, default ok
}

on *:dialog:nsconf:*:*:{
  if ($devent == init) {
    mdxinit
    mdx SetControlMDX $dname 1 ListView report rowselect showsel nosortheader grid > $mdxviews
    did -i $dname 1 1 headerdims 130 100 120 120
    did -i $dname 1 1 headertext Pseudo $chr(9) Mot de Passe $chr(9) Pseudo du NickServ $chr(9) Rseau
    nsconf.refresh
  }
  if ($devent == sclick) {
    if ($did == 2) { set %edit.nsconf $did(2) | _d edit.nsconf }
    if ($did == 3) && $did(1).sel { delnsconf $v1 }
    if ($did == 4) && $did(1).sel { set %edit.nsconf $did(4) | _d edit.nsconf }
  }
  if ($devent == dclick) && ($did == 1) { set %edit.nsconf Modifier | _d edit.nsconf }
}

Alias -l nsconf.refresh {
  if $dialog(nsconf) {
    did -r nsconf 1
    var %i = 1 | while $read($nsf,%i) {
      tokenize 32 $v1
      did -a nsconf 1 0 0 0 0 $1 $chr(9) $str(*,$len($2)) $chr(9) $3 $chr(9) $4
      inc %i
    }
  }
}
Alias -l delnsconf {
  if $nsf {
    write -dl $+ $calc($1 - 1) $nsf
    nsconf.refresh
    did -c nsconf 1 $iif($lines($nsf) >= $calc($1 - 1),$1,$calc($1 - 1))
  }
}
dialog edit.nsconf {
  title Gestion NickServ - %edit.nsconf
  size -1 -1 130 70
  option dbu
  text "Pseudo :", 1, 5 5 52 9, right
  edit "", 5, 60 4 65 10, autohs
  text "Mot de passe :", 2, 5 17 52 9, right
  edit "", 6, 60 16 65 10, autohs
  text "Pseudo du NickServ :", 3, 5 29 52 9, right
  edit "", 7, 60 28 65 10, autohs
  text "Rseau :", 4, 5 41 52 9, right
  edit "", 8, 60 40 65 10, autohs
  button "", 9, 60 55 65 11, default ok
  button "Annuler", 10, 5 55 52 11, ok
}
on *:dialog:edit.nsconf:*:*:{
  if $dialog(nsconf) {
    var %f = $nsf
    tokenize 32 $read(%f,$calc($did(nsconf,1).sel - 1))
    if ($devent == init) {
      mdxinit | mdx SetFont $dname 9 +a 13 750 verdana
      if (%edit.nsconf == Ajouter) { did -ra $dname 5 $pseudo($me) | did -ra $dname 7 $ns | did -ra $dname 8 $net }
      if (%edit.nsconf == Modifier) { did -ra $dname 5 $1 | did -ra $dname 6 $2 | did -ra $dname 7 $3 | did -ra $dname 8 $4 }
      if !$did(5) || !$did(6) || !$did(7) || $regex($did(5),$chr(32)) || $regex($did(6),$chr(32)) || $regex($did(7),$chr(32)) { 
        did -b $dname 9 
      }
      did -a $dname 9 %edit.nsconf
      unset %edit.nsconf
    }
    elseif ($devent == edit) {
      did $iif(!$did(5) || ($did(6) == $null) || !$did(7) || !$did(8) || $regex($did(5),$chr(32)) || $regex($did(6),$chr(32)) || $regex($did(7),$chr(32)) || $regex($did(8),$chr(32)),-b,-e) $dname 9
    }
    elseif ($devent == sclick) {
      if ($did == 9) {
        var %l = $calc($did(nsconf,1).sel - 1) , %a = $did(5) $did(6) $did(7) $did(8)
        tokenize 32 $read(%f,%l)
        if ($did(9) == Ajouter) { write %f %a }
        if ($did(9) == Modifier) { write -l $+ %l %f %a }
        nsconf.refresh 
        dialog -x $dname
      }
    }
  }
}

on *:NOTICE:*/*IDENTIFY*:?:{
  var %i = 1 , %m = $strip($1-) , %id = $false , %f = $nsf | while $read(%f,%i) {
    tokenize 32 $v1
    if (($me == $1) || ($gettok($me,1,$asc($sep1)) == $1)) && ($nick == $gettok($3,1,64)) && ($net == $4) { 
      if $regex(%m,/\/msg $3 IDENTIFY/i) {
        scid $cid x* $3 IDENTIFY $2 
        var %id = $true
      }
      elseif $regex(%m,/\/ $+ $3 IDENTIFY/i) {
        scid $cid $3 IDENTIFY $2 
        var %id = $true
      }
    }
    if %id { 
      iecho Commande d'identification sur $3 effectue $par(pseudo : $me)
      var %i = $lines(%f)
    }
    inc %i
  }
}

raw 433:*:{ 
  ;if $istok(Tgl0beIRC,$net($server),59) { return }
  if $istok(loggingon;connected,$status,59) {
    var %p = $2 , %i = 1 | while $read($nsf,%i) {
      tokenize 32 $v1
      if ((%p == $1) || ($gettok(%p,1,$asc($sep1)) == $1)) && ($4 == $net($server)) { var %x = $1- , %i = $lines($nsf) }
      inc %i
    }
    if %x {
      tokenize 32 %x
      var %tnick = $left($pseudo(%p),$iif($nicklen,$calc($nicklen - 5),15)) $+ _ $+ $rand(a,z) $+ $base($rand(0,999),10,10,3)
      htcd -w nickserv.*
      htc nickserv.mnick %p
      htc nickserv.tnick %tnick
      htc nickserv.pass $2
      htc nickserv.ns $3
      if ($status == loggingon) { tnick $htc(nickserv.tnick) }
      elseif $gettok(%p,2,$asc($sep1)) && ($pseudo(%p) == $pseudo($me)) { n $gettok(%p,2,$asc($sep1)) }
    }
  }
  halt
}

raw 004:*:{
  if ($me == $htc(nickserv.tnick)) { 
    msg* $$htc(nickserv.ns) $iif($net == Tgl0beIRC,RECOVER,GHOST) $$htc(nickserv.mnick) $$htc(nickserv.pass) 
    .timer 1 1 nickserv.mnick
  }
}

on *:QUIT:if ($nick == $htc(nickserv.mnick)) { nickserv.mnick }

alias -l nickserv.mnick {
  if $htc(nickserv.mnick) {
    nick $htc(nickserv.mnick)
    htcd -w nickserv.*
    watch.bots | if (o !isin $usermode) && $h(auto-oper) { auth.oper }
    .timer 1 1 nickserv.rejoin
  }
}
alias nickserv.rejoin {
  var %i = 1 | while $chan(%i) {
    if $istok(joining;kicked,$chan(%i).status,59) { join -n $chan(%i) }
    inc %i
  }
}

alias register {
  var %pass = $$1 , %email = $$2 , %f = $nsf
  ns register %pass %email
  var %i = 1 | while $read(%f,%i) {
    tokenize 32 $v1
    if (($me == $1) || ($gettok($me,1,$asc($sep1)) == $1)) && ($4 == $net) {  
      write -dl $+ %i %f
    }
    else inc %i
  }
  write %f $me %pass $$ns $$net
  nsconf.refresh
}
alias drop {
  ns drop
  var %i = 1 , %f = $nsf | while $read(%f,%i) {
    tokenize 32 $v1
    if (($me == $1) || ($gettok($me,1,$asc($sep1)) == $1)) && ($4 == $net) {  
      write -dl $+ %i %f
    }
    else inc %i
  }
  nsconf.refresh
}



;============
;PROFIL DIALOVA
;============

alias _profil {
  if !$dialova || !$1 || $isnickprov($1) { return }
  var %f = $iif($hget(profil.id,$1),http://www.dialova.com/profil.php?membre= $+ $v1,http://www.dialova.com/chat/getid.php?nick= $+ $1)
  if $isid { return %f } | url %f
}
on *:ACTIVE:?:afficher.profilresa
alias afficher.profilresa if $dialova && $h(afficher.profilresa) && !$dialog(profil. $+ $active) { profil }
alias -l profil- return $ansi($iif($profil($1) != $null,$v1,-))
alias -l profil {
  if $isid && $1 { return $ht(profil. $+ $1) }
  var %n = $iif($query($1),$v1,$query($active)) , %p = profil. $+ %n
  if $dialova && %n && ($cid == $activecid) && !$isrobot(%n) && !$isnickprov(%n) {
    htd -w profil.*
    ht profil.nick %n
    ht profil.cid $cid
    profil.1
  }
}
alias -l profil.1 {
  var %id = $hget(profil.id,$profil(nick))
  if %id { 
    ht profil.id $v1 
    ht profil.url $_profil($profil(nick))
    profil.2 
  }
  elseif (%id == $null) { _sockopen profil.1 dialova.com 80 }
}
on *:sockopen:profil.1:{
  if !$sockerr {
    var %sendtext = pseudorecherche= $+ $profil(nick) $+ & $+ chercher=Rechercher+un+pseudo
    sockwrite -n $sockname POST /les-profils.php HTTP/1.1
    sockwrite -n $sockname Host: www.dialova.com
    sockwrite -n $sockname User-Agent: $user-agent 
    sockwrite -n $sockname Referer: http://www.dialova.com/les-profils.php
    sockwrite -n $sockname Content-Type: application/x-www-form-urlencoded
    sockwrite -n $sockname Content-Length: $len(%sendtext)
    sockwrite -n $sockname Connection: close    
    sockwrite -n $sockname   
    sockwrite -t $sockname %sendtext
  }
}
on *:sockread:profil.1:{
  sockread %profil.1
  if !$profil(id) && !$profil(url) && $profil(nick) && $regex(%profil.1,/<A HREF="profil\.php\?membre=(\d+)"/i) {
    ht profil.id $regml(1) 
    hadd -m profil.id $profil(nick) $profil(id)
    ht profil.url $_profil($profil(nick))
    .sockclose $sockname
    unset %profil.1 | profil.2
  }
}
;on *:sockclose:profil.1:unset %profil.1 | profil.2
alias wfx dll $fichier(system/dlls/WindowFX.dll) $1-
dialog _profil {
  title "profil"
  size -1 -1 0 0
  option dbu
  icon 1, 1 3 65 54
  text "Pseudo", 2, 70 3 28 8, right
  text "ge", 3, 70 11 28 8, hide right
  text "Sexe", 4, 155 3 33 8, hide right
  text "N(e) le", 5, 155 11 33 8, hide right
  text "Pays", 6, 70 19 28 8, hide right
  text "Lieu", 7, 155 19 33 8, hide right
  text "Inscrit le", 8, 70 31 28 8, hide right
  text "Description", 9, 70 39 28 8, hide right
  text "", 10, 70 25 203 6, hide
  text "", 12, 104 3 46 8
  text "", 13, 104 11 46 8
  text "", 14, 194 3 67 8
  text "", 15, 194 11 67 8
  text "", 16, 104 19 46 8
  text "", 17, 194 19 67 8
  text "", 18, 103 31 170 8
  text "", 19, 103 39 170 20
  icon 25, 261 6 16 16
}
on *:DIALOG:profil.*:*:*:{
  var %n = $right($dname,-7)
  if ($devent == init) {
    mdxinit
    dialog -bs $dname 0 0 280 50
    scid $profil(cid) wfx SetChild %n > $dname
    scid $profil(cid) wfx SetStyle $dname > notitle staticedge
    mdx SetColor $dname 2,3,4,5,6,7,8,9,10 text $rgb(60,120,200)
    mdx SetFont $dname 2,3,4,5,6,7,8,9,10,12,13,14,15,16,17,18,19 +a 13 500 Tahoma
    did -ra $dname 12 %n
    did -ra $dname 10 $str($tiret2,42)
    profil.img %n
    .timer 1 0 window -a %n
  }
  elseif ($devent == sclick) && ($did == 1) { _profil %n }
}
alias -l profil.img {
  var %p = profil. $+ $$1 , %f = $iif($2,$2,$findfile($fichier(system/images/profil/),$1 $+ .*,1))
  if $dialog(%p) && $isfile(%f) && $regex(%f,/\.(jpe?g|png|bmp|gif)"?$/i) { 
    did -gv %p 1 %f 
  }
}
alias -l profil.2 { 
  if !$profil(id) { hadd -m profil.id $profil(nick) 0 }
  elseif $isurl($profil(url)) && ($query($profil(nick)) == $active) { 
    var %p = profil. $+ $v1
    if !$dialog(%p) { dialog -mi %p _profil }
    _sockopen profil.2 dialova.com 80 
  }
}
on *:SOCKOPEN:profil.2:{
  if !$sockerr {
    sockwrite -n $sockname GET $isurl($profil(url)).a HTTP/1.1
    sockwrite -n $sockname Host: $isurl($profil(url)).d
    sockwrite -n $sockname Connection: close
    sockwrite -n $sockname $crlf
  }
}
on *:SOCKREAD:profil.2:{
  sockread %profil.2
  ;ht profil.img $fichier(System\Images\defaut.jpg)
  if $regex(%profil.2,/<li>(.+)<\/li><li>- <div class="fb-like"/i) {
    tokenize 32 $remove($regml(1),</li>,<li>-)
    if $istok(Homme;Femme,$3,59) { ht profil.sexe $3 }
    if ($4 isnum) && ($5 == ans) { ht profil.age $4-5 } | else tokenize 32 $1-3 0 0 $4-
    ht profil.pays $6
    ht profil.lieu $7-
  }
  elseif $regex(%profil.2,/<u>Date de naissance<\/u> : (\d+)-(\d+)-(\d+)?<br \/>/) { 
    ht profil.naissance $iif($regml(1) == 1,1er,$v1) $replace($base($regml(2),10,10,2),01,janvier,02,fvrier,03,mars,04,avril,05,mai,06,juin,07,juillet,08,aot,09,septembre,10,octobre,11,novembre,12,dcembre) $iif($regml(3),$v1,????)
    if $gettok($ht(profil.naissance),1-2,32) == $gettok($tps,2-3,32)) { ht profil.anniv 1 }
  }
  elseif $regex(%profil.2,/<u>Date de naissance<\/u> : --(\d+)<br \/>/) { 
    ht profil.naissance en $regml(1)
  }
  elseif $regex(%profil.2,/<u>Date d'inscription<\/u> : (\d+)-(\d+)-(\d+)<br \/>/) { 
    ht profil.inscription $gettok($tps($ctime($+($regml(1),/,$regml(2),/,$regml(3)))),2-4,32)
  }
  elseif !$profil(imgurl) && $regex(%profil.2,/<img src="(photo\/miniature- $+ $profil(nick) $+ -.+\.(jpe?g|png|bmp|gif))"/i) {  
    ht profil.imgurl $+(http://www.dialova.com/,$replace($regml(1),$chr(32),% $+ 20))
  }
  elseif $regex(%profil.2,/<div id="contenu2">/) { ht profil.description1 $true }
  elseif $profil(description1) && $regex(%profil.2,/<p>(.+)<(\/p|br \/)>/) { 
    ht profil.description $regsubex($regml(1),/<img src="chat\/emoticons\/(\S+).gif"[^>]*>/ig,$emoticon2ascii(\t))
  }
}
on *:SOCKCLOSE:profil.2:{
  unset %profil.2 
  profil.3
}
alias -l profil.3 {
  var %p = profil. $+ $profil(nick)
  if $dialog(%p) {
    var %ld = $len($profil-(description))
    if (%ld >= 150) { mdx SetFont %p 19 +a 12 500 Tahoma }
    if (%ld >= 180) { mdx SetFont %p 19 +a 11 500 Tahoma }
    var %e | if ($profil-(sexe) == Femme) { var %e = e } | elseif ($profil-(sexe) == -) { var %e = (e) }
    did -ra %p 5 $puttok($did(%p,5),N $+ %e,1,32)
    did -ra %p 8 $puttok($did(%p,5),Inscrit $+ %e,1,32)
    var %i = 3 | while (%i <= 10) { did -v %p %i | inc %i }
    var %k = age;sexe;naissance;pays;lieu;inscription;description , %i = 13
    while (%i <= 19) {
      did -ra %p %i $profil-($gettok(%k,$calc(%i - 12),59))
      inc %i
    }
    var %anniv = $fichier(system/images/icones/anniv.png) 
    if $profil(anniv) && $isfile(%anniv) { did -gv %p 25 %anniv }
    var %pays = $profil-(pays) , %lieu
    if $istok(France;Belgique,%pays,59) { var %lieu = Dpartement }
    elseif (%pays == Belgique) { var %lieu = Dpartement }
    elseif (%pays == Suisse) { var %lieu = Canton }
    elseif (%pays == Canada) { var %lieu = Province }
    if %lieu { did -ra %p 7 $v1 } | else { did -r %p 7,17 }
    if $isurl($profil(imgurl)) && $regex($profil(imgurl),/\.(jpe?g|png|bmp|gif)$/i) {
      ht profil.img $fichier(System\Images\profil\ $+ $profil(nick) $+ . $+ $regml(1))
      _sockopen profil.3 dialova.com 80 
    }
    else profil.4
  }
}
on *:SOCKOPEN:profil.3:{
  if !$sockerr {
    var %d = $fichier(System/Images/profil/) | if !$isdir(%d) { .mkdir %d }
    profil.clear $profil(nick)
    sockwrite -n $sockname GET $isurl($profil(imgurl)).a HTTP/1.1
    sockwrite -n $sockname Host: $isurl($profil(imgurl)).d
    sockwrite -n $sockname Connection: close
    sockwrite -n $sockname $crlf
  }
}
on *:SOCKREAD:profil.3:{
  sockread &a
  bwrite $profil(img) -1 -1 &a
}
on *:sockclose:profil.3:{
  var %f = $profil(img)
  if $isfile(%f) {
    bread %f 0 $file(%f).size &a | bread %f $calc($bfind(&a,1,13 10 13 10) + 3) $file(%f).size &a | .remove %f | bwrite %f -1 -1 &a
  }
  profil.4
}
alias -l profil.4 {
  var %p = profil. $+ $profil(nick)
  if $dialog(%p) {
    if !$profil(img) { 
      ht profil.img $fichier(System\Images\defaut.jpg) 
      profil.clear $profil(nick)
    }
    profil.img $profil(nick) $profil(img)
    htd -w profil.*
  }
}
alias -l emoticon2ascii {
  var %a = smile tongue biggrin sad blushing wink mad blink kiss 
  var %b = :) :p :D :( :$ ;) :[ O_O (kiss)
  if $findtok(%a,$1,1,32) { return $gettok(%b,$v1,32) }
}
on *:exit:if !$maxdedracy { profil.clear }
on *:start:if !$maxdedracy { profil.clear }
alias profil.clear {
  var %d = $fichier(system/images/profil/)
  if $isdir(%d) {
    var %x = $findfile(%d,$iif($1,$1 $+ .) $+ *,0,.remove $1-)
    if !$findfile(%d,*,0) { .rmdir %d }
  }
}
